package OntologiaTurismo;

import jade.content.onto.*;
import jade.content.schema.*;
import jade.util.leap.HashMap;
import jade.content.lang.Codec;
import jade.core.CaseInsensitiveString;
import nl.uva.psy.swi.beangenerator.ProtegeIntrospector;
import nl.uva.psy.swi.beangenerator.SlotHolder;
import nl.uva.psy.swi.beangenerator.ProtegeTools;

/** file: TourismOntology.java
 * @author ontology bean generator
 * @version 2004/11/25, 18:49:59
 */
public class TourismOntology extends jade.content.onto.Ontology implements ProtegeTools.ProtegeOntology {
   /**
    * These hashmap store a mapping from jade names to either protege names of SlotHolder 
    * containing the protege names.  And vice versa
    */  
   private HashMap jadeToProtege;

   
  //NAME
  public static final String ONTOLOGY_NAME = "TourismOntology";
  // The singleton instance of this ontology
  private static ProtegeIntrospector introspect = new ProtegeIntrospector();
  private static Ontology theInstance = new TourismOntology();
  public static Ontology getInstance() {
     return theInstance;
  }

   // ProtegeOntology methods
   public SlotHolder getSlotNameFromJADEName(SlotHolder jadeSlot) {
     return (SlotHolder) jadeToProtege.get(jadeSlot);
   }


   // storing the information
   private void storeSlotName(String jadeName, String javaClassName, String slotName){
       jadeToProtege.put(new SlotHolder(javaClassName, jadeName), new SlotHolder(javaClassName, slotName));
   }


   // VOCABULARY
    public static final String BOOKSIGHT_NUMBEROFPEOPLE="NumberOfPeople";
    public static final String BOOKSIGHT_TIMEPERIOD="TimePeriod";
    public static final String BOOKSIGHT_NAME="Name";
    public static final String BOOKSIGHT_SIGHTTEMPLATE="SightTemplate";
    public static final String BOOKSIGHT="BookSight";
    public static final String SIMPLESEARCHLIST_AGENTADDRESSES="AgentAddresses";
    public static final String SIMPLESEARCHLIST_TOURISMTEMPLATELIST="TourismTemplateList";
    public static final String SIMPLESEARCHLIST="SimpleSearchList";
    public static final String MODIFSEARCHLIST="ModifSearchList";
    public static final String MODIFSEARCHLIST_CONFIRMANTION = "modifTemplateList";
    public static final String SIMPLESEARCH_SIGHTPREFS="SightPrefs";
    public static final String SIMPLESEARCH_TOURISMTEMPLATE="TourismTemplate";
    public static final String SIMPLESEARCH="SimpleSearch";
    public static final String CREATETIMETABLE_TIMELIST="TimeList";
    public static final String CREATETIMETABLE_TIMEPERIOD="TimePeriod";
    public static final String CREATETIMETABLE_SIGHTPREFSLIST="SightPrefsList";
    public static final String CREATETIMETABLE_TOURISMTEMPLATELIST="TourismTemplateList";
    public static final String CREATETIMETABLE_ZIP_CODE="Zip_code";
    public static final String CREATETIMETABLE="CreateTimeTable";
    public static final String PINGSIGHT_TOURISMTEMPLATE="TourismTemplate";
    public static final String PINGSIGHT="PingSight";
    public static final String SIGHTDETAILS_ALLSIGHTINFOS="AllSightInfos";
    public static final String SIGHTDETAILS="SightDetails";
    public static final String RESERVE_AGENTSAID="AgentsAID";
    public static final String RESERVE_RESERVETIME="ReserveTime";
    public static final String RESERVE_NUMBEROFVISITORS="NumberOfVisitors";
    public static final String RESERVE_TIME="Time";
    public static final String RESERVE="Reserve";
    
    public static final String CANCEL_AGENTSAID="AgentsAID";
    public static final String CANCEL_CANCELTIME="CancelTime";
    public static final String CANCEL_TIME="Time";
    public static final String CANCEL="Cancellation";
    
    public static final String REGISTERSIGHTAGENT_SIGHTTEMPLATE="SightTemplate";
    public static final String REGISTERSIGHTAGENT_AGENTSAID="AgentsAID";
    public static final String REGISTERSIGHTAGENT="RegisterSightAgent";
    public static final String DISH_DISH_NAME="Dish_name";
    public static final String DISH_DISH_PRICE="Dish_price";
    public static final String DISH_DESCRIPTION="Description";
    public static final String DISH_INGREDIENTS="Ingredients";
    public static final String DISH="Dish";
    public static final String PASTA="Pasta";
    public static final String LIQUOR="Liquor";
    public static final String ZONE="Zone";
    public static final String SIGHT_TIMETABLE="Timetable";
    public static final String SIGHT_NAME="Name";
    public static final String SIGHT_AREA="Area";
    public static final String SIGHT_PARKING="Parking";
    public static final String SIGHT_SIGHT_ADDRESS="Sight_address";
    public static final String SIGHT_ID="Id";
    public static final String SIGHT="Sight";
    public static final String WINE_DESSERT="Wine_dessert";
    public static final String DRINK_DRINK_NAME="drink_name";
    public static final String DRINK_DRINK_PRICE="drink_price";
    public static final String DRINK_DRINK_SIZE="drink_size";
    public static final String DRINK="Drink";
    public static final String VEGETABLES="Vegetables";
    public static final String MUSEUMPREFERENCES_GUIDE="Guide";
    public static final String MUSEUMPREFERENCES_GUIDELANGUAGE="GuideLanguage";
    public static final String MUSEUMPREFERENCES="MuseumPreferences";
    public static final String COLD_DRINK="Cold_drink";
    public static final String BEACH="Beach";
    public static final String MENU_MENU_PRICE="Menu_price";
    public static final String MENU_ENABLE_DRINK="Enable_drink";
    public static final String MENU_VALIDITY="Validity";
    public static final String MENU_ENABLE_COFFEE_TEA="Enable_coffee_tea";
    public static final String MENU_MENU_DESCRIPTION="Menu_description";
    public static final String MENU_MENU_PLAT="Menu_plat";
    public static final String MENU="Menu";
    public static final String PEOPLE_AND_PRICE_PEOPLE="People";
    public static final String PEOPLE_AND_PRICE_PRICE="Price";
    public static final String PEOPLE_AND_PRICE="People_and_Price";
    public static final String PLAY_WRITER="writer";
    public static final String PLAY="play";
    public static final String BUBBLY="Bubbly";
    public static final String RESTAURANT_WITH_SHOW="With_Show";
    public static final String RESTAURANT_PARKING_ATTENDANT="Parking_attendant";
    public static final String RESTAURANT_FOR_GROUPS="For_Groups";
    public static final String RESTAURANT_NON_SMOKING="Non_Smoking";
    public static final String RESTAURANT_BUFFET="Buffet";
    public static final String RESTAURANT_TAKE_AWAY="Take_Away";
    public static final String RESTAURANT_RESTAURANT_CARTE="Restaurant_carte";
    public static final String RESTAURANT_RESTAURANT_SPECIALTY="Restaurant_Specialty";
    public static final String RESTAURANT_RESTAURANT_MENU="Restaurant_menu";
    public static final String RESTAURANT_FAST_FOOD="Fast_Food";
    public static final String RESTAURANT_HOME_COOKING="Home_Cooking";
    public static final String RESTAURANT_ROMANTIC="Romantic";
    public static final String RESTAURANT_AVERAGE_PRICE="Average_price";
    public static final String RESTAURANT_RESTAURANT_TYPE="Restaurant_type";
    public static final String RESTAURANT_PRIVATE_ROOM="Private_Room";

    public static final String RESTAURANT_RTIMING="rtiming";

    public static final String RESTAURANT="Restaurant";
    public static final String FISH="Fish";
    public static final String DESSERT="Dessert";
    public static final String RICE="Rice";
    public static final String COFFEE="coffee";
    public static final String TEA="Tea";
    public static final String WINE_REGION="Region";
    public static final String WINE_BOTTLING_YEAR="Bottling_year";
    public static final String WINE="Wine";
    public static final String EAT_CARTE_DISH="Carte_Dish";
    public static final String EAT="Eat";
    public static final String RED="Red";
    public static final String SOUP="Soup";
    public static final String PARK="Park";
    public static final String TIME_PERIOD_OPEN="Open";
    public static final String TIME_PERIOD_CLOSE="Close";
    public static final String TIME_PERIOD_TIME="Time";
    public static final String TIME_PERIOD="Time_period";
    public static final String TIME_PERIOD_TIMEBLA="timebla";

    public static final String MUSEUM_PERMANENT_EXHIBITION="Permanent_exhibition";
    public static final String MUSEUM_MUSEUM_PRICE="Museum_price";
    public static final String MUSEUM_MUSEUM_KIND="Museum_kind";
    public static final String MUSEUM_MUSEUM_FREE_DATE="Museum_free_date";
    public static final String MUSEUM_CURRENT_EXHIBITION="Current_exhibition";
    public static final String MUSEUM_MUSEUM_DATA_OF_CLOSING="Museum_data_of_closing";
    public static final String MUSEUM_MTIMING="mtiming";
    public static final String MUSEUM="Museum";
    
    public static final String PLACE_PLACE_TYPE="Place_type";
    public static final String PLACE_PTIMING="ptiming";
    public static final String PLACE="Place";
   
    public static final String CARTE_FOOD="Food";
    public static final String CARTE_DRINKS="Drinks";
    public static final String CARTE="Carte";
    public static final String INTERESTING_BUIDINGS="Interesting_Buidings";
    public static final String SHOW_GENRE="Genre";
    public static final String SHOW_STARRINGS="Starrings";
    public static final String SHOW_TITTLE="Tittle";
    public static final String SHOW_RUN_TIME="Run_time";
    public static final String SHOW_TIME_START="Time_start";
    public static final String SHOW_RELEASE_DATE="Release_Date";
    public static final String SHOW_DIRECTED_BY="Directed_by";
    public static final String SHOW="show";
    public static final String FILM="film";
    public static final String EGG="Egg";
    public static final String WHITE="White";
    public static final String SIGHTPREFERENCES_CHEAP="Cheap";
    public static final String SIGHTPREFERENCES_EXPENSIVE="Expensive";
    public static final String SIGHTPREFERENCES="SightPreferences";
    public static final String MEAT="Meat";
    public static final String ENCLOSURE_CREDIT_CARD="Credit_card";
    public static final String ENCLOSURE="Enclosure";
    public static final String DIET="Diet";
    public static final String TOURISM="Tourism";
    public static final String RESTAURANTPREFERENCES_CHEAPDRINKS="CheapDrinks";
    public static final String RESTAURANTPREFERENCES_CHEAPPLATES="CheapPlates";
    public static final String RESTAURANTPREFERENCES_CHEAPMENUES="CheapMenues";
    public static final String RESTAURANTPREFERENCES="RestaurantPreferences";
    public static final String ADDRESS_STREET="Street";
    public static final String ADDRESS_STREET_NUMBER="Street_number";
    public static final String ADDRESS_COUNTRY="Country";
    public static final String ADDRESS_WEB="Web";
    public static final String ADDRESS_NEIGHBORHOOD="Neighborhood";
    public static final String ADDRESS_PHONE="Phone";
    public static final String ADDRESS_ZIP_CODE="Zip_code";
    public static final String ADDRESS_CITY="City";
    public static final String ADDRESS_FAX="Fax";
    public static final String ADDRESS="Address";
    public static final String THEATRE_PLAY_NOW="play_now";
    public static final String THEATRE="Theatre";
    public static final String PINK="Pink";
    public static final String CINEMA_FILMS="films";
    public static final String CINEMA="Cinema";

  /**
   * Constructor
  */
  private TourismOntology(){ 
    super(ONTOLOGY_NAME, BasicOntology.getInstance());
    introspect.setOntology(this);
    jadeToProtege = new HashMap();
    try { 

    // adding Concept(s)
    ConceptSchema cinemaSchema = new ConceptSchema(CINEMA);
    add(cinemaSchema, OntologiaTurismo.Cinema.class);
    ConceptSchema pinkSchema = new ConceptSchema(PINK);
    add(pinkSchema, OntologiaTurismo.Pink.class);
    ConceptSchema theatreSchema = new ConceptSchema(THEATRE);
    add(theatreSchema, OntologiaTurismo.Theatre.class);
    ConceptSchema addressSchema = new ConceptSchema(ADDRESS);
    add(addressSchema, OntologiaTurismo.Address.class);
    ConceptSchema restaurantPreferencesSchema = new ConceptSchema(RESTAURANTPREFERENCES);
    add(restaurantPreferencesSchema, OntologiaTurismo.RestaurantPreferences.class);
    ConceptSchema tourismSchema = new ConceptSchema(TOURISM);
    add(tourismSchema, OntologiaTurismo.Tourism.class);
    ConceptSchema dietSchema = new ConceptSchema(DIET);
    add(dietSchema, OntologiaTurismo.Diet.class);
    ConceptSchema enclosureSchema = new ConceptSchema(ENCLOSURE);
    add(enclosureSchema, OntologiaTurismo.Enclosure.class);
    ConceptSchema meatSchema = new ConceptSchema(MEAT);
    add(meatSchema, OntologiaTurismo.Meat.class);
    ConceptSchema sightPreferencesSchema = new ConceptSchema(SIGHTPREFERENCES);
    add(sightPreferencesSchema, OntologiaTurismo.SightPreferences.class);
    ConceptSchema whiteSchema = new ConceptSchema(WHITE);
    add(whiteSchema, OntologiaTurismo.White.class);
    ConceptSchema eggSchema = new ConceptSchema(EGG);
    add(eggSchema, OntologiaTurismo.Egg.class);
    ConceptSchema filmSchema = new ConceptSchema(FILM);
    add(filmSchema, OntologiaTurismo.Film.class);
    ConceptSchema showSchema = new ConceptSchema(SHOW);
    add(showSchema, OntologiaTurismo.Show.class);
    ConceptSchema interesting_BuidingsSchema = new ConceptSchema(INTERESTING_BUIDINGS);
    add(interesting_BuidingsSchema, OntologiaTurismo.Interesting_Buidings.class);
    ConceptSchema carteSchema = new ConceptSchema(CARTE);
    add(carteSchema, OntologiaTurismo.Carte.class);
    ConceptSchema museumSchema = new ConceptSchema(MUSEUM);
    add(museumSchema, OntologiaTurismo.Museum.class);
    ConceptSchema placeSchema = new ConceptSchema(PLACE);
    add(placeSchema, OntologiaTurismo.Place.class);
    ConceptSchema time_periodSchema = new ConceptSchema(TIME_PERIOD);
    add(time_periodSchema, OntologiaTurismo.Time_period.class);
    ConceptSchema parkSchema = new ConceptSchema(PARK);
    add(parkSchema, OntologiaTurismo.Park.class);
    ConceptSchema soupSchema = new ConceptSchema(SOUP);
    add(soupSchema, OntologiaTurismo.Soup.class);
    ConceptSchema redSchema = new ConceptSchema(RED);
    add(redSchema, OntologiaTurismo.Red.class);
    ConceptSchema eatSchema = new ConceptSchema(EAT);
    add(eatSchema, OntologiaTurismo.Eat.class);
    ConceptSchema wineSchema = new ConceptSchema(WINE);
    add(wineSchema, OntologiaTurismo.Wine.class);
    ConceptSchema teaSchema = new ConceptSchema(TEA);
    add(teaSchema, OntologiaTurismo.Tea.class);
    ConceptSchema coffeeSchema = new ConceptSchema(COFFEE);
    add(coffeeSchema, OntologiaTurismo.Coffee.class);
    ConceptSchema riceSchema = new ConceptSchema(RICE);
    add(riceSchema, OntologiaTurismo.Rice.class);
    ConceptSchema dessertSchema = new ConceptSchema(DESSERT);
    add(dessertSchema, OntologiaTurismo.Dessert.class);
    ConceptSchema fishSchema = new ConceptSchema(FISH);
    add(fishSchema, OntologiaTurismo.Fish.class);
    ConceptSchema restaurantSchema = new ConceptSchema(RESTAURANT);
    add(restaurantSchema, OntologiaTurismo.Restaurant.class);
    ConceptSchema bubblySchema = new ConceptSchema(BUBBLY);
    add(bubblySchema, OntologiaTurismo.Bubbly.class);
    ConceptSchema playSchema = new ConceptSchema(PLAY);
    add(playSchema, OntologiaTurismo.Play.class);
    ConceptSchema people_and_PriceSchema = new ConceptSchema(PEOPLE_AND_PRICE);
    add(people_and_PriceSchema, OntologiaTurismo.People_and_Price.class);
    ConceptSchema menuSchema = new ConceptSchema(MENU);
    add(menuSchema, OntologiaTurismo.Menu.class);
    ConceptSchema beachSchema = new ConceptSchema(BEACH);
    add(beachSchema, OntologiaTurismo.Beach.class);
    ConceptSchema cold_drinkSchema = new ConceptSchema(COLD_DRINK);
    add(cold_drinkSchema, OntologiaTurismo.Cold_drink.class);
    ConceptSchema museumPreferencesSchema = new ConceptSchema(MUSEUMPREFERENCES);
    add(museumPreferencesSchema, OntologiaTurismo.MuseumPreferences.class);
    ConceptSchema vegetablesSchema = new ConceptSchema(VEGETABLES);
    add(vegetablesSchema, OntologiaTurismo.Vegetables.class);
    ConceptSchema drinkSchema = new ConceptSchema(DRINK);
    add(drinkSchema, OntologiaTurismo.Drink.class);
    ConceptSchema wine_dessertSchema = new ConceptSchema(WINE_DESSERT);
    add(wine_dessertSchema, OntologiaTurismo.Wine_dessert.class);
    ConceptSchema sightSchema = new ConceptSchema(SIGHT);
    add(sightSchema, OntologiaTurismo.Sight.class);
    ConceptSchema zoneSchema = new ConceptSchema(ZONE);
    add(zoneSchema, OntologiaTurismo.Zone.class);
    ConceptSchema liquorSchema = new ConceptSchema(LIQUOR);
    add(liquorSchema, OntologiaTurismo.Liquor.class);
    ConceptSchema pastaSchema = new ConceptSchema(PASTA);
    add(pastaSchema, OntologiaTurismo.Pasta.class);
    ConceptSchema dishSchema = new ConceptSchema(DISH);
    add(dishSchema, OntologiaTurismo.Dish.class);

    // adding AgentAction(s)
    AgentActionSchema registerSightAgentSchema = new AgentActionSchema(REGISTERSIGHTAGENT);
    add(registerSightAgentSchema, OntologiaTurismo.RegisterSightAgent.class);
    AgentActionSchema reserveSchema = new AgentActionSchema(RESERVE);
    add(reserveSchema, OntologiaTurismo.Reserve.class);

    AgentActionSchema cancellationSchema = new AgentActionSchema(CANCEL);
    add(cancellationSchema, OntologiaTurismo.Cancellation.class);
    
    AgentActionSchema simpleModifListSchema = new AgentActionSchema(MODIFSEARCHLIST);
    add(simpleModifListSchema, OntologiaTurismo.ModifSearchList.class);

    // adding Predicate(s)
    PredicateSchema sightDetailsSchema = new PredicateSchema(SIGHTDETAILS);
    add(sightDetailsSchema, OntologiaTurismo.SightDetails.class);
    PredicateSchema pingSightSchema = new PredicateSchema(PINGSIGHT);
    add(pingSightSchema, OntologiaTurismo.PingSight.class);
    PredicateSchema createTimeTableSchema = new PredicateSchema(CREATETIMETABLE);
    add(createTimeTableSchema, OntologiaTurismo.CreateTimeTable.class);
    PredicateSchema simpleSearchSchema = new PredicateSchema(SIMPLESEARCH);
    add(simpleSearchSchema, OntologiaTurismo.SimpleSearch.class);
    PredicateSchema simpleSearchListSchema = new PredicateSchema(SIMPLESEARCHLIST);
    add(simpleSearchListSchema, OntologiaTurismo.SimpleSearchList.class);
    PredicateSchema bookSightSchema = new PredicateSchema(BOOKSIGHT);
    add(bookSightSchema, OntologiaTurismo.BookSight.class);


    
    // adding fields
    cinemaSchema.add(CINEMA_FILMS, filmSchema, 1, ObjectSchema.UNLIMITED);
    theatreSchema.add(THEATRE_PLAY_NOW, playSchema, ObjectSchema.OPTIONAL);
    addressSchema.add(ADDRESS_FAX, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    addressSchema.add(ADDRESS_CITY, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
    addressSchema.add(ADDRESS_ZIP_CODE, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.OPTIONAL);
    addressSchema.add(ADDRESS_PHONE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    addressSchema.add(ADDRESS_NEIGHBORHOOD, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    addressSchema.add(ADDRESS_WEB, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    addressSchema.add(ADDRESS_COUNTRY, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
    addressSchema.add(ADDRESS_STREET_NUMBER, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.MANDATORY);
    addressSchema.add(ADDRESS_STREET, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
    restaurantPreferencesSchema.add(RESTAURANTPREFERENCES_CHEAPMENUES, (TermSchema)getSchema(BasicOntology.BOOLEAN), ObjectSchema.OPTIONAL);
    restaurantPreferencesSchema.add(RESTAURANTPREFERENCES_CHEAPPLATES, (TermSchema)getSchema(BasicOntology.BOOLEAN), ObjectSchema.OPTIONAL);
    restaurantPreferencesSchema.add(RESTAURANTPREFERENCES_CHEAPDRINKS, (TermSchema)getSchema(BasicOntology.BOOLEAN), ObjectSchema.OPTIONAL);
    enclosureSchema.add(ENCLOSURE_CREDIT_CARD, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    sightPreferencesSchema.add(SIGHTPREFERENCES_EXPENSIVE, (TermSchema)getSchema(BasicOntology.BOOLEAN), ObjectSchema.OPTIONAL);
    sightPreferencesSchema.add(SIGHTPREFERENCES_CHEAP, (TermSchema)getSchema(BasicOntology.BOOLEAN), ObjectSchema.OPTIONAL);
    showSchema.add(SHOW_DIRECTED_BY, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    showSchema.add(SHOW_RELEASE_DATE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    showSchema.add(SHOW_TIME_START, (TermSchema)getSchema(BasicOntology.STRING), 0, ObjectSchema.UNLIMITED);
    showSchema.add(SHOW_RUN_TIME, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.OPTIONAL);
    showSchema.add(SHOW_TITTLE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    showSchema.add(SHOW_STARRINGS, (TermSchema)getSchema(BasicOntology.STRING), 0, ObjectSchema.UNLIMITED);
    showSchema.add(SHOW_GENRE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    carteSchema.add(CARTE_DRINKS, drinkSchema, 0, ObjectSchema.UNLIMITED);
    carteSchema.add(CARTE_FOOD, eatSchema, ObjectSchema.OPTIONAL);
    museumSchema.add(MUSEUM_MUSEUM_DATA_OF_CLOSING, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    museumSchema.add(MUSEUM_CURRENT_EXHIBITION, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    museumSchema.add(MUSEUM_MUSEUM_FREE_DATE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    museumSchema.add(MUSEUM_MUSEUM_KIND, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    museumSchema.add(MUSEUM_MUSEUM_PRICE, people_and_PriceSchema, ObjectSchema.OPTIONAL);
    museumSchema.add(MUSEUM_PERMANENT_EXHIBITION, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    museumSchema.add(MUSEUM_MTIMING, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    
    placeSchema.add(PLACE_PLACE_TYPE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    placeSchema.add(PLACE_PTIMING, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    
    time_periodSchema.add(TIME_PERIOD_CLOSE, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.OPTIONAL);
    time_periodSchema.add(TIME_PERIOD_OPEN, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.OPTIONAL);
    time_periodSchema.add(TIME_PERIOD_TIME, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    time_periodSchema.add(TIME_PERIOD_TIMEBLA, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);

    
    eatSchema.add(EAT_CARTE_DISH, dishSchema, 0, ObjectSchema.UNLIMITED);
    wineSchema.add(WINE_BOTTLING_YEAR, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.MANDATORY);
    wineSchema.add(WINE_REGION, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
    restaurantSchema.add(RESTAURANT_PRIVATE_ROOM, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_RESTAURANT_TYPE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_AVERAGE_PRICE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_ROMANTIC, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_HOME_COOKING, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_FAST_FOOD, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_RESTAURANT_MENU, menuSchema, 0, ObjectSchema.UNLIMITED);
    restaurantSchema.add(RESTAURANT_RESTAURANT_SPECIALTY, dishSchema, 0, ObjectSchema.UNLIMITED);
    restaurantSchema.add(RESTAURANT_RESTAURANT_CARTE, carteSchema, ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_TAKE_AWAY, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_BUFFET, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_NON_SMOKING, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_FOR_GROUPS, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_PARKING_ATTENDANT, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    restaurantSchema.add(RESTAURANT_WITH_SHOW, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    
    restaurantSchema.add(RESTAURANT_RTIMING, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    
    playSchema.add(PLAY_WRITER, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    people_and_PriceSchema.add(PEOPLE_AND_PRICE_PRICE, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.MANDATORY);
    people_and_PriceSchema.add(PEOPLE_AND_PRICE_PEOPLE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
    menuSchema.add(MENU_MENU_PLAT, dishSchema, 1, ObjectSchema.UNLIMITED);
    menuSchema.add(MENU_MENU_DESCRIPTION, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    menuSchema.add(MENU_ENABLE_COFFEE_TEA, (TermSchema)getSchema(BasicOntology.BOOLEAN), ObjectSchema.MANDATORY);
    menuSchema.add(MENU_VALIDITY, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
    menuSchema.add(MENU_ENABLE_DRINK, (TermSchema)getSchema(BasicOntology.BOOLEAN), ObjectSchema.MANDATORY);
    menuSchema.add(MENU_MENU_PRICE, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.MANDATORY);
    museumPreferencesSchema.add(MUSEUMPREFERENCES_GUIDELANGUAGE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    museumPreferencesSchema.add(MUSEUMPREFERENCES_GUIDE, (TermSchema)getSchema(BasicOntology.BOOLEAN), ObjectSchema.OPTIONAL);
    drinkSchema.add(DRINK_DRINK_SIZE, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
    drinkSchema.add(DRINK_DRINK_PRICE, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.MANDATORY);
    drinkSchema.add(DRINK_DRINK_NAME, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
    sightSchema.add(SIGHT_ID, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    sightSchema.add(SIGHT_SIGHT_ADDRESS, addressSchema, ObjectSchema.OPTIONAL);
    sightSchema.add(SIGHT_PARKING, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    sightSchema.add(SIGHT_AREA, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    sightSchema.add(SIGHT_NAME, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    sightSchema.add(SIGHT_TIMETABLE, time_periodSchema, 0, ObjectSchema.UNLIMITED);
    dishSchema.add(DISH_INGREDIENTS, (TermSchema)getSchema(BasicOntology.STRING), 0, ObjectSchema.UNLIMITED);
    dishSchema.add(DISH_DESCRIPTION, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    dishSchema.add(DISH_DISH_PRICE, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.MANDATORY);
    dishSchema.add(DISH_DISH_NAME, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.MANDATORY);
    registerSightAgentSchema.add(REGISTERSIGHTAGENT_AGENTSAID, (ConceptSchema)getSchema(BasicOntology.AID), ObjectSchema.MANDATORY);
    registerSightAgentSchema.add(REGISTERSIGHTAGENT_SIGHTTEMPLATE, new ConceptSchema("Concept"), ObjectSchema.MANDATORY);
    reserveSchema.add(RESERVE_NUMBEROFVISITORS, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.MANDATORY);
    reserveSchema.add(RESERVE_RESERVETIME, time_periodSchema, ObjectSchema.OPTIONAL);
    reserveSchema.add(RESERVE_AGENTSAID, (ConceptSchema)getSchema(BasicOntology.AID), ObjectSchema.MANDATORY);

    cancellationSchema.add(CANCEL_CANCELTIME, time_periodSchema, ObjectSchema.OPTIONAL);
    cancellationSchema.add(CANCEL_AGENTSAID, (ConceptSchema)getSchema(BasicOntology.AID), ObjectSchema.MANDATORY);

    sightDetailsSchema.add(SIGHTDETAILS_ALLSIGHTINFOS, new ConceptSchema("Concept"), ObjectSchema.OPTIONAL);
    pingSightSchema.add(PINGSIGHT_TOURISMTEMPLATE, new ConceptSchema("Concept"), ObjectSchema.MANDATORY);
    createTimeTableSchema.add(CREATETIMETABLE_ZIP_CODE, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.OPTIONAL);
    createTimeTableSchema.add(CREATETIMETABLE_TOURISMTEMPLATELIST, new ConceptSchema("Concept"), 0, ObjectSchema.UNLIMITED);
    createTimeTableSchema.add(CREATETIMETABLE_SIGHTPREFSLIST, new ConceptSchema("Concept"), 0, ObjectSchema.UNLIMITED);
    createTimeTableSchema.add(CREATETIMETABLE_TIMEPERIOD, time_periodSchema, ObjectSchema.OPTIONAL);
    createTimeTableSchema.add(CREATETIMETABLE_TIMELIST, time_periodSchema, 0, ObjectSchema.UNLIMITED);
    simpleSearchSchema.add(SIMPLESEARCH_TOURISMTEMPLATE, new ConceptSchema("Concept"), ObjectSchema.MANDATORY);
    simpleSearchSchema.add(SIMPLESEARCH_SIGHTPREFS, new ConceptSchema("Concept"), ObjectSchema.OPTIONAL);
    simpleSearchListSchema.add(SIMPLESEARCHLIST_TOURISMTEMPLATELIST, new ConceptSchema("Concept"), 0, ObjectSchema.UNLIMITED);
    simpleSearchListSchema.add(SIMPLESEARCHLIST_AGENTADDRESSES, (ConceptSchema)getSchema(BasicOntology.AID), 0, ObjectSchema.UNLIMITED);
    
    simpleModifListSchema.add(MODIFSEARCHLIST_CONFIRMANTION, (TermSchema)getSchema(BasicOntology.STRING), 0, ObjectSchema.UNLIMITED);
    bookSightSchema.add(BOOKSIGHT_SIGHTTEMPLATE, new ConceptSchema("Concept"), ObjectSchema.MANDATORY);
    bookSightSchema.add(BOOKSIGHT_NAME, (TermSchema)getSchema(BasicOntology.STRING), ObjectSchema.OPTIONAL);
    bookSightSchema.add(BOOKSIGHT_TIMEPERIOD, time_periodSchema, ObjectSchema.OPTIONAL);
    bookSightSchema.add(BOOKSIGHT_NUMBEROFPEOPLE, (TermSchema)getSchema(BasicOntology.INTEGER), ObjectSchema.MANDATORY);

    // adding name mappings
    storeSlotName("films", "OntologiaTurismo.Cinema", "films");  
    storeSlotName("play_now", "OntologiaTurismo.Theatre", "play_now");  
    storeSlotName("Fax", "OntologiaTurismo.Address", "Fax");  
    storeSlotName("City", "OntologiaTurismo.Address", "City");  
    storeSlotName("Zip_code", "OntologiaTurismo.Address", "Zip_code");  
    storeSlotName("Phone", "OntologiaTurismo.Address", "Phone");  
    storeSlotName("Neighborhood", "OntologiaTurismo.Address", "Neighborhood");  
    storeSlotName("Web", "OntologiaTurismo.Address", "Web");  
    storeSlotName("Country", "OntologiaTurismo.Address", "Country");  
    storeSlotName("Street_number", "OntologiaTurismo.Address", "Street_number");  
    storeSlotName("Street", "OntologiaTurismo.Address", "Street");  
    storeSlotName("CheapMenues", "OntologiaTurismo.RestaurantPreferences", "CheapMenues");  
    storeSlotName("CheapPlates", "OntologiaTurismo.RestaurantPreferences", "CheapPlates");  
    storeSlotName("CheapDrinks", "OntologiaTurismo.RestaurantPreferences", "CheapDrinks");  
    storeSlotName("Credit_card", "OntologiaTurismo.Enclosure", "Credit_card");  
    storeSlotName("Expensive", "OntologiaTurismo.SightPreferences", "Expensive");  
    storeSlotName("Cheap", "OntologiaTurismo.SightPreferences", "Cheap");  
    storeSlotName("Directed_by", "OntologiaTurismo.Show", "Directed_by");  
    storeSlotName("Release_Date", "OntologiaTurismo.Show", "Release_Date");  
    storeSlotName("Time_start", "OntologiaTurismo.Show", "Time_start");  
    storeSlotName("Run_time", "OntologiaTurismo.Show", "Run_time");  
    storeSlotName("Tittle", "OntologiaTurismo.Show", "Tittle");  
    storeSlotName("Starrings", "OntologiaTurismo.Show", "Starrings");  
    storeSlotName("Genre", "OntologiaTurismo.Show", "Genre");  
    storeSlotName("Drinks", "OntologiaTurismo.Carte", "Drinks");  
    storeSlotName("Food", "OntologiaTurismo.Carte", "Food");  
    storeSlotName("Museum_data_of_closing", "OntologiaTurismo.Museum", "Museum_data_of_closing");  
    storeSlotName("Current_exhibition", "OntologiaTurismo.Museum", "Current_exhibition");  
    storeSlotName("Museum_free_date", "OntologiaTurismo.Museum", "Museum_free_date");  
    storeSlotName("Museum_kind", "OntologiaTurismo.Museum", "Museum_kind");  
    storeSlotName("Museum_price", "OntologiaTurismo.Museum", "Museum_price");  
    storeSlotName("Permanent_exhibition", "OntologiaTurismo.Museum", "Permanent_exhibition");  
    storeSlotName("mtiming", "OntologiaTurismo.Museum", "mtiming");  
    
    storeSlotName("Place_type", "OntologiaTurismo.Place", "Place_type"); 
    storeSlotName("ptiming", "OntologiaTurismo.Place", "ptiming");    
    
    storeSlotName("Close", "OntologiaTurismo.Time_period", "Close");  
    storeSlotName("Open", "OntologiaTurismo.Time_period", "Open");  
    storeSlotName("Time", "OntologiaTurismo.Time_period", "Time");  
    storeSlotName("timebla", "OntologiaTurismo.Time_period", "timebla");  
    storeSlotName("Carte_Dish", "OntologiaTurismo.Eat", "Carte_Dish");  
    storeSlotName("Bottling_year", "OntologiaTurismo.Wine", "Bottling_year");  
    storeSlotName("Region", "OntologiaTurismo.Wine", "Region");  
    storeSlotName("Private_Room", "OntologiaTurismo.Restaurant", "Private_Room");  
    storeSlotName("Restaurant_type", "OntologiaTurismo.Restaurant", "Restaurant_type");  
    storeSlotName("Average_price", "OntologiaTurismo.Restaurant", "Average_price");  
    storeSlotName("Romantic", "OntologiaTurismo.Restaurant", "Romantic");  
    storeSlotName("Home_Cooking", "OntologiaTurismo.Restaurant", "Home_Cooking");  
    storeSlotName("Fast_Food", "OntologiaTurismo.Restaurant", "Fast_Food");  
    storeSlotName("Restaurant_menu", "OntologiaTurismo.Restaurant", "Restaurant_menu");  
    storeSlotName("Restaurant_Specialty", "OntologiaTurismo.Restaurant", "Restaurant_Specialty");  
    storeSlotName("Restaurant_carte", "OntologiaTurismo.Restaurant", "Restaurant_carte");  
    storeSlotName("Take_Away", "OntologiaTurismo.Restaurant", "Take_Away");  
    storeSlotName("Buffet", "OntologiaTurismo.Restaurant", "Buffet");  
    storeSlotName("Non_Smoking", "OntologiaTurismo.Restaurant", "Non_Smoking");  
    storeSlotName("For_Groups", "OntologiaTurismo.Restaurant", "For_Groups");  
    storeSlotName("Parking_attendant", "OntologiaTurismo.Restaurant", "Parking_attendant");  
    storeSlotName("With_Show", "OntologiaTurismo.Restaurant", "With_Show");  

    storeSlotName("rtiming", "OntologiaTurismo.Restaurant", "rtiming");  

    storeSlotName("writer", "OntologiaTurismo.Play", "writer");  
    storeSlotName("Price", "OntologiaTurismo.People_and_Price", "Price");  
    storeSlotName("People", "OntologiaTurismo.People_and_Price", "People");  
    storeSlotName("Menu_plat", "OntologiaTurismo.Menu", "Menu_plat");  
    storeSlotName("Menu_description", "OntologiaTurismo.Menu", "Menu_description");  
    storeSlotName("Enable_coffee_tea", "OntologiaTurismo.Menu", "Enable_coffee_tea");  
    storeSlotName("Validity", "OntologiaTurismo.Menu", "Validity");  
    storeSlotName("Enable_drink", "OntologiaTurismo.Menu", "Enable_drink");  
    storeSlotName("Menu_price", "OntologiaTurismo.Menu", "Menu_price");  
    storeSlotName("GuideLanguage", "OntologiaTurismo.MuseumPreferences", "GuideLanguage");  
    storeSlotName("Guide", "OntologiaTurismo.MuseumPreferences", "Guide");  
    storeSlotName("drink_size", "OntologiaTurismo.Drink", "drink_size");  
    storeSlotName("drink_price", "OntologiaTurismo.Drink", "drink_price");  
    storeSlotName("drink_name", "OntologiaTurismo.Drink", "drink_name");  
    storeSlotName("Id", "OntologiaTurismo.Sight", "Id");  
    storeSlotName("Sight_address", "OntologiaTurismo.Sight", "Sight_address");  
    storeSlotName("Parking", "OntologiaTurismo.Sight", "Parking");  
    storeSlotName("Area", "OntologiaTurismo.Sight", "Area");  
    storeSlotName("Name", "OntologiaTurismo.Sight", "Name");  
    storeSlotName("Timetable", "OntologiaTurismo.Sight", "Timetable");  
    storeSlotName("Ingredients", "OntologiaTurismo.Dish", "Ingredients");  
    storeSlotName("Description", "OntologiaTurismo.Dish", "Description");  
    storeSlotName("Dish_price", "OntologiaTurismo.Dish", "Dish_price");  
    storeSlotName("Dish_name", "OntologiaTurismo.Dish", "Dish_name");  
    storeSlotName("AgentsAID", "OntologiaTurismo.RegisterSightAgent", "AgentsAID");  
    storeSlotName("SightTemplate", "OntologiaTurismo.RegisterSightAgent", "SightTemplate");  
    storeSlotName("NumberOfVisitors", "OntologiaTurismo.Reserve", "NumberOfVisitors");  
    storeSlotName("ReserveTime", "OntologiaTurismo.Reserve", "ReserveTime");  
    storeSlotName("AgentsAID", "OntologiaTurismo.Reserve", "AgentsAID");  
    storeSlotName("Time", "OntologiaTurismo.Reserve", "Time");  

    storeSlotName("CancelTime", "OntologiaTurismo.Cancellation", "CancelTime");  
    storeSlotName("AgentsAID", "OntologiaTurismo.Cancellation", "AgentsAID");  
    storeSlotName("Time", "OntologiaTurismo.Cancellation", "Time");  
 

    storeSlotName("AllSightInfos", "OntologiaTurismo.SightDetails", "AllSightInfos");  
    storeSlotName("TourismTemplate", "OntologiaTurismo.PingSight", "TourismTemplate");  
    storeSlotName("Zip_code", "OntologiaTurismo.CreateTimeTable", "Zip_code");  
    storeSlotName("TourismTemplateList", "OntologiaTurismo.CreateTimeTable", "TourismTemplateList");  
    storeSlotName("SightPrefsList", "OntologiaTurismo.CreateTimeTable", "SightPrefsList");  
    storeSlotName("TimePeriod", "OntologiaTurismo.CreateTimeTable", "TimePeriod");  
    storeSlotName("TimeList", "OntologiaTurismo.CreateTimeTable", "TimeList");  
    storeSlotName("TourismTemplate", "OntologiaTurismo.SimpleSearch", "TourismTemplate");  
    storeSlotName("SightPrefs", "OntologiaTurismo.SimpleSearch", "SightPrefs");  
    storeSlotName("TourismTemplateList", "OntologiaTurismo.SimpleSearchList", "TourismTemplateList");  
    storeSlotName("AgentAddresses", "OntologiaTurismo.SimpleSearchList", "AgentAddresses");  
    storeSlotName("modifTemplateList", "OntologiaTurismo.ModifSearchList", "modifTemplateList");  
    storeSlotName("SightTemplate", "OntologiaTurismo.BookSight", "SightTemplate");  
    storeSlotName("Name", "OntologiaTurismo.BookSight", "Name");  
    storeSlotName("TimePeriod", "OntologiaTurismo.BookSight", "TimePeriod");  
    storeSlotName("NumberOfPeople", "OntologiaTurismo.BookSight", "NumberOfPeople");  

    // adding inheritance
    cinemaSchema.addSuperSchema(enclosureSchema);
    pinkSchema.addSuperSchema(wineSchema);
    theatreSchema.addSuperSchema(enclosureSchema);
    restaurantPreferencesSchema.addSuperSchema(sightPreferencesSchema);
    enclosureSchema.addSuperSchema(sightSchema);
    meatSchema.addSuperSchema(eatSchema);
    sightPreferencesSchema.addSuperSchema(tourismSchema);
    whiteSchema.addSuperSchema(wineSchema);
    eggSchema.addSuperSchema(eatSchema);
    filmSchema.addSuperSchema(showSchema);
    interesting_BuidingsSchema.addSuperSchema(enclosureSchema);
    carteSchema.addSuperSchema(dietSchema);
    museumSchema.addSuperSchema(enclosureSchema);
    placeSchema.addSuperSchema(enclosureSchema);
    parkSchema.addSuperSchema(zoneSchema);
    soupSchema.addSuperSchema(eatSchema);
    redSchema.addSuperSchema(wineSchema);
    eatSchema.addSuperSchema(dietSchema);
    wineSchema.addSuperSchema(drinkSchema);
    teaSchema.addSuperSchema(drinkSchema);
    coffeeSchema.addSuperSchema(drinkSchema);
    riceSchema.addSuperSchema(eatSchema);
    dessertSchema.addSuperSchema(eatSchema);
    fishSchema.addSuperSchema(eatSchema);
    restaurantSchema.addSuperSchema(enclosureSchema);
    bubblySchema.addSuperSchema(wineSchema);
    playSchema.addSuperSchema(showSchema);
    menuSchema.addSuperSchema(dietSchema);
    beachSchema.addSuperSchema(zoneSchema);
    cold_drinkSchema.addSuperSchema(drinkSchema);
    museumPreferencesSchema.addSuperSchema(sightPreferencesSchema);
    vegetablesSchema.addSuperSchema(eatSchema);
    drinkSchema.addSuperSchema(dietSchema);
    wine_dessertSchema.addSuperSchema(wineSchema);
    sightSchema.addSuperSchema(tourismSchema);
    zoneSchema.addSuperSchema(sightSchema);
    liquorSchema.addSuperSchema(drinkSchema);
    pastaSchema.addSuperSchema(eatSchema);
    dishSchema.addSuperSchema(dietSchema);

   }catch (java.lang.Exception e) {e.printStackTrace();}
  }
  }
